/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gsi;

    import java.util.*;

/**
 *
 * @author demel
 */
public class Node {
    Gsi model;
    String  name;
    String  txtType;
    enum TypIn {OR,AND};
    enum TypOut{D,ST};
    TypIn typIn;
    TypOut typOut;
    List<Arc> fwdLinks = new ArrayList<Arc>(20);
    List<Arc> bwdLinks = new ArrayList<Arc>(20);
    Stat stat = new Stat();

    public Node(String pName, String TxtType) {
        name = pName;
        this.txtType = TxtType;
        setType();
    }
    
    public Node(java.util.Scanner f, Gsi model) {
        this.model = model;
        name = f.next().toLowerCase();
        txtType = f.next().toLowerCase();
        printNode();
        setType();
    }

    private void setType() {
        if        (txtType.equalsIgnoreCase("stor")) {
            typIn = TypIn.OR;  typOut = TypOut.ST;
        } else if (txtType.equalsIgnoreCase("stand")) {
            typIn = TypIn.AND; typOut = TypOut.ST;
        } else if (txtType.equalsIgnoreCase("dor")) {
            typIn = TypIn.OR;  typOut = TypOut.D;
        } else if (txtType.equalsIgnoreCase("dand")) {
            typIn = TypIn.AND; typOut = TypOut.D;
        } else {
            model.die("Unknown type of node: "+txtType);
        }
    }
    
    public String toString() {
        return "Node:  " + name + "  " + txtType + "\n";
    }

    public void printNode() {
        System.out.print(toString());
    }

    public void fire() {
        model.log(2, model.time+":  node  "+name+"  fired");
        stat.regValue(model.time);
        if (typOut == TypOut.D) {
            // start all outgoing arcs
            for (Arc arc: fwdLinks) {
                arc.start();
            }
        } else {
            // start one randomly selected arc
            Double p = model.rng.nextDouble();
            for (Arc arc: fwdLinks) {
                p -= arc.probab;
                if (p <= 0.0) {
                    arc.start();
                    break;
                }
            }
            // safeguard if sum of probab < 1.0
            if (p > 0.0) {
                fwdLinks.get(0).start();
            }
        }
    }

    public void notified(Arc fromArc) {
        // fromArc stopped. Try to fire ouserlves.

        model.log(4, "...trying to fire node "+name);
        if (typIn == TypIn.OR) {
            // clear signal and fire
            fromArc.signalling = false;
            fire();
        } else {
            // if all bwd arcs signalled  cler all signals and fire
            boolean canBeFired=true;
            for (Arc a: bwdLinks) {
                if (!a.signalling) {
                    canBeFired = false;
                    break;
                }
            }
            if (canBeFired) {
                for (Arc a: bwdLinks) {
                    a.signalling = false;
                }
                fire();
            }
        }
    }

}
